/*
 *  ngtk/c/ngtk_winstack.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include <signal.h>

static void ngtk_sigint(int sig)	/* FIXME: sometimes, the test program */
{                                   /* gets segfault when typing ctrl-c   */
	ngtk_fade_out();
	ngtk_stop_display();
	ngtk_fade_in();
	fprintf(stderr, "SIGINT caught (ctrl-c pressed)\n");

	exit(0);
}

void ngtk_launch_display(void)
{
	use_ngtk_main = 0;

	(void)signal(SIGINT, ngtk_sigint);
    initscr();
    ngtk_init_input();
    noecho();
    start_color();
    ngtk_init_pairs();
    cbreak();
	background = (ngtk_win_t *)malloc(sizeof(ngtk_win_t));

    background->win = stdscr;
    background->pan = new_panel(background->win);
    background->cursor_flag = 1;

	prev_buffer = background;

}

int ngtk_stop_display(void)
{
	ngtk_pull_win(background);
    erase();
    wrefresh(background->win);
#ifdef HAVE_SLANG
    SLang_reset_tty();
#endif
    endwin();

    return(0);
}